Groovy Documentation

## org.codehaus.groovy.transform
[Java] Class ReadWriteLockASTTransformation

    java.lang.Object
      org.codehaus.groovy.transform.ReadWriteLockASTTransformation

All Implemented Interfaces:
  ASTTransformation, org.objectweb.asm.Opcodes

    @GroovyASTTransformation(phase = CompilePhase.CANONICALIZATION)
    public class ReadWriteLockASTTransformation
    extends java.lang.Object

Handles generation of code for the `@`WithReadLock and `@`WithWriteLock annotation.
This transformation adds an instance of ReentrantReadWriteLock to the class.
Any method annotated with

WithReadLock:
  will obtain a read lock and release it in a finally block.
  Any method annotated with

WithWriteLock:
  will obtain a write lock and release it in a finally block.
  For more information see WithReadLock and WithWriteLock

Authors:
  Hamlet D'Arcy

Method Summary
`void` | `visit(ASTNode[] nodes, SourceUnit source)`

Methods inherited from class java.lang.Object
java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Method Detail

### visit

    public void visit(ASTNode[] nodes, SourceUnit source)

Groovy Documentation